(document:surround "/std/frame")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-standalone")

;;; Functions
(define centerface (make-widget "centerface"))
(define modules (make-attribute 'modules))
(define sections (make-attribute 'sections))
(define current-module (make-attribute 'current-module))

title (_ "System management center")
width 600
height 560

(define *helps* (make-cell '()))

(define (help-topic url)
 (let ((topic (cond-assoc (symbol->string url) (cell-ref *helps*))))
   (woo-get-option (woo-read-first "/help/" 'topic topic) 'url)))

(define (make-help data)
  (cell-set! *helps*
    (map (lambda(x)
           (cons (woo-get-option x 'uri)
	         (woo-get-option x 'help)))
	 data)))

(define (not-empty-section category module-data)
  (find (lambda(x) (string=? category (woo-get-option x 'category)))
	module-data))

(define (make-section module-data)
  (lambda(x)
    (let ((category (woo-get-option x 'category)))
      (and (not-empty-section category module-data)
	   (list category
		 (woo-get-option x 'name)
		 (woo-get-option x 'comment)
		 (woo-get-option x 'icon))))))

(define (make-module x)
  (list (woo-get-option x 'category)
	(woo-get-option x 'uri)
	(woo-get-option x 'name)))

;;; UI
(document:id cf (centerface
                  (frame:page)
		  (when selected
		    (let ((url (cf current-module)))
		      (frame:call-on-leave)
		      (frame:replace url)
		      (document:root help (help-topic url))))))

(frame:init-on-leave)

;;; Logic

(document:root
  (when loaded
    (let ((section-data (woo-list "/menu/avail_sections"))
	  (module-data  (woo-list "/menu/avail_modules" 'ui "qt")))
      (make-help module-data)
      (document:root help (woo-get-option (woo-read-first "/help/" 'topic "acc-qt") 'url))
      (cf sections (filter-map (make-section module-data) section-data)
          modules  (map make-module module-data)))))
